/**
 * @file receive.c
 * @author TheGreenBow (support@thegreenbow.com)
 * @brief 
 * @version 0.1
 * @date 2020-11-10
 * 
 * @copyright Copyright (c) 2020
 * 
 */

#include "receive.h"

#include <linux/skbuff.h>
#include <linux/ip.h>
#include <linux/inet.h>

#include "frame_utils.h"
#include "private_api.h"
#include "debug.h"

extern struct net_device *tgbtun; //net device used

bool tgb3882c7a127b21ecdf4f5296818e781eaf8c99d07cde36e1e12f6c29fa662f9ec(struct sk_buff *skb) {
    unsigned int status;
    pr_debug("ESP packet in !\n");
   
    skb_push(skb, sizeof (struct ethhdr));//add data to the start of a buffer
    status = p_api_frame_decrypt(eth_hdr(skb)->h_dest, htons(ip_hdr(skb)->tot_len) + ETH_HLEN);

    if(unlikely(status == 0)) return false;
    return true;
}

bool tgbadaaa63e39d6bb41076e494c930704cd975a06c6f39bd34b412ac2cb3f48527d(uint8_t* frame, const uint32_t size) {
    struct sk_buff* skb, *trailer;
        
    dump_packet(frame,size);
    skb = alloc_skb(size+ETH_HLEN+2,GFP_ATOMIC);
    if (unlikely(!skb)) goto drop;

    memcpy(skb_put(skb, size), frame, size);
    kfree(frame); //free buffer get from ipseclib

    skb->dev = tgbtun;
    skb->protocol = eth_type_trans(skb, tgbtun);
    skb->pkt_type = PACKET_HOST;
    skb->ip_summed = CHECKSUM_UNNECESSARY;
    tgbtun->stats.rx_packets++;
    tgbtun->stats.rx_bytes += size;
    skb_data_align(skb,1,&trailer);
    if(unlikely(netif_receive_skb(skb) == NET_RX_DROP)) {
        goto drop;
    }

    return true;

drop:
    tgbtun->stats.rx_dropped++;
    pr_err("packet dropped\n");
    return false;
    
}